/*
-------------------------------------------------------------------------------
    This file is a part of the Vst Preset Generator
    Copyright (C) 2007  Francois Mazen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-------------------------------------------------------------------------------
  Name: vpgtools.h
  Author: Francois Mazen
  Date: 28/05/07 16:25
  Description: some tools because of big-endian/little-endian notation in the 
               vst preset files
-------------------------------------------------------------------------------
*/


//Convert from hex (inverted) to long
qint32 import_long(char* data)
{
       return (qint32)data[3] + 
              256 * (qint32)data[2] + 
              256*256 * (qint32)data[1] + 
              256*256*256 * (qint32)data[0];
}

//convert from long to hex (inverted)
void export_long(qint32 num, char* data)
{
      qint32 temp = num;
      qint32 rest = 0;
      
      rest= temp%256;
      data[3] = rest;
      
      temp = temp - rest; //* 256^0
      rest = (temp/256)%256;
      data[2] = rest;
      
      temp = temp - (rest * 256);//256^1
      rest = (temp/256)%256;
      data[1] = rest;
      temp = temp - (rest * 256 * 256); //256^2
      
      data[0] = temp / 256; //%256 but always <256
}
